void Boot() {

  delay(500);

  //INIT LEDs, first read button states and then update LEDs
  for (int i = 0; i < 7; i++) {
    shifter.setPin(LEDPINS[i], buttonState_PB[i]);
  }

  // 2-WAY SWITCHES // LED 7 - 10 / PB 7 - 8
  int j = 0;
  for (int i = 0; i < 2; i++) {
    j = 2 * i;
    boolean state = buttonState_PB[i + 7];
    shifter.setPin(LEDPINS[j + 7], !state);
    shifter.setPin(LEDPINS[j + 8], state);
  }

  // 3-WAY SWITCHES // LED 11 - 29 / PB 9 - 15
  for (int i = 0; i < 6; i++) {
    if (PreviousbuttonState_PB[i + 9] == 0) {
      shifter.setPin(LEDPINS[11 + 3 * i], 1);
      shifter.setPin(LEDPINS[12 + 3 * i], 0);
      shifter.setPin(LEDPINS[13 + 3 * i], 0);
    }

    if (PreviousbuttonState_PB[i + 9] == 1) {
      shifter.setPin(LEDPINS[11 + 3 * i], 0);
      shifter.setPin(LEDPINS[12 + 3 * i], 1);
      shifter.setPin(LEDPINS[13 + 3 * i], 0);
    }

    if (PreviousbuttonState_PB[i + 9] == 2) {
      shifter.setPin(LEDPINS[11 + 3 * i], 0);
      shifter.setPin(LEDPINS[12 + 3 * i], 0);
      shifter.setPin(LEDPINS[13 + 3 * i], 1);
    }
  }
  shifter.write();

  for (int j = 0; j < 20; j++) {
    for (int i = 0; i < 8; i++) {
      for (int j = 0; j < 3; j ++) {
        digitalWrite(SPINS[j], muxChannel[i][j]);
      }
      delayMicroseconds(10);

      Analog[AnaIndex[i]] = ((Analog[AnaIndex[i]]) * (100 - Smoothing) + (analogRead(VOUT_ANA1) * Smoothing)) / 100;
      Analog[AnaIndex[i + 8]] = ((Analog[AnaIndex[i + 8]]) * (100 - Smoothing) + (analogRead(VOUT_ANA2) * Smoothing)) / 100;
      Analog[AnaIndex[i + 16]] = ((Analog[AnaIndex[i + 16]]) * (100 - Smoothing) + (analogRead(VOUT_ANA3) * Smoothing)) / 100;
    }
  }

}




