void Leds() {

  if (!SEQ_MODE) {

    if (SEQ_OUT) {
      // ON/OFF SWITCHES // LEDs 0 - 6 / PBs 0 - 6
      for (int i = 0; i < 7; i++) {
        shifter.setPin(LEDPINS[i], buttonState_PB[i]);

      }
      // 2-WAY SWITCHES // LED 7 - 10 / PB 7 - 8
      int j = 0;
      for (int i = 0; i < 2; i++) {
        j = 2 * i;
        boolean state = buttonState_PB[i + 7];
        shifter.setPin(LEDPINS[j + 7], !state);
        shifter.setPin(LEDPINS[j + 8], state);

      }
      // 3-WAY SWITCHES // LED 11 - 29 / PB 9 - 15
      for (int i = 0; i < 6; i++) {
        if (buttonState_PB[i + 9] == 0) {
          shifter.setPin(LEDPINS[11 + 3 * i], 1);
          shifter.setPin(LEDPINS[12 + 3 * i], 0);
          shifter.setPin(LEDPINS[13 + 3 * i], 0);
        }

        if (buttonState_PB[i + 9] == 1) {
          shifter.setPin(LEDPINS[11 + 3 * i], 0);
          shifter.setPin(LEDPINS[12 + 3 * i], 1);
          shifter.setPin(LEDPINS[13 + 3 * i], 0);
        }

        if (buttonState_PB[i + 9] == 2) {
          shifter.setPin(LEDPINS[11 + 3 * i], 0);
          shifter.setPin(LEDPINS[12 + 3 * i], 0);
          shifter.setPin(LEDPINS[13 + 3 * i], 1);
        }
      }
      SEQ_OUT = 0;
    }

    // ON/OFF SWITCHES // LEDs 0 - 6 / PBs 0 - 6
    for (int i = 0; i < 7; i++) {
      if (PBSTATUS[i] == HIGH) {
        shifter.setPin(LEDPINS[i], buttonState_PB[i]);
      }
    }
    // 2-WAY SWITCHES // LED 7 - 10 / PB 7 - 8
    int j = 0;
    for (int i = 0; i < 2; i++) {
      if (PBSTATUS[i + 7] == HIGH) {
        j = 2 * i;
        boolean state = buttonState_PB[i + 7];
        shifter.setPin(LEDPINS[j + 7], !state);
        shifter.setPin(LEDPINS[j + 8], state);
      }
    }
    // 3-WAY SWITCHES // LED 11 - 29 / PB 9 - 15
    for (int i = 0; i < 6; i++) {
      if (PBSTATUS[i + 9] == HIGH) {
        if (buttonState_PB[i + 9] == 0) {
          shifter.setPin(LEDPINS[11 + 3 * i], 1);
          shifter.setPin(LEDPINS[12 + 3 * i], 0);
          shifter.setPin(LEDPINS[13 + 3 * i], 0);
        }

        if (buttonState_PB[i + 9] == 1) {
          shifter.setPin(LEDPINS[11 + 3 * i], 0);
          shifter.setPin(LEDPINS[12 + 3 * i], 1);
          shifter.setPin(LEDPINS[13 + 3 * i], 0);
        }

        if (buttonState_PB[i + 9] == 2) {
          shifter.setPin(LEDPINS[11 + 3 * i], 0);
          shifter.setPin(LEDPINS[12 + 3 * i], 0);
          shifter.setPin(LEDPINS[13 + 3 * i], 1);
        }
      }
    }

    //Quickly blink the shift LED after INIT
    if (InitFlag) {
      for (int i = 0; i < 8; i++) {
        shifter.setPin(LEDPINS[6], LedState);
        delay(100);
        LedState = !LedState;
        shifter.write();
      }

      //If Range PB was on lowest position, set LED back on
      if (PreviousbuttonState_PB[14] == 0) {
        shifter.setPin(LEDPINS[26], 1);
      }
    }
  }


  if (SEQ_MODE) {

    //LED MANAGEMENT FOR SEQ

    // LEDs management for step sequencer
    if ((seq_direction == 1) || (seq_direction == 3)) {

      if ((step_counter < 8) && (seq_page == 0)) {
        shifter.setPin(LEDSEQ[step_counter], step_state[step_counter]);
        shifter.setPin(LEDSEQ[step_counter - seq_direction_ratio], 0);
      }

      if ((step_counter > 7) && (seq_page == 1)) {
        shifter.setPin(LEDSEQ[step_counter - 8], step_state[step_counter]);
        shifter.setPin(LEDSEQ[step_counter - seq_direction_ratio - 8], 0);
      }
    }

    if (seq_direction == 1) {
      if ((step_counter == 0) || (step_counter == 8)) {
        shifter.setPin(LEDSEQ[(7)], 0);
      }

      if ((step_counter == 0) && (sequence_length_buffer < 9)) {
        shifter.setPin(LEDSEQ[(sequence_length_buffer - 1)], 0);
      }

      if ((step_counter == 0) && (sequence_length_buffer > 8)) {
        shifter.setPin(LEDSEQ[(sequence_length_buffer - 1 - 8)], 0);
      }
    }

    if (seq_direction == 3) {
      if (step_counter == sequence_length_buffer - 1) {
        shifter.setPin(LEDSEQ[(0)], 0);
      }

      if (step_counter == 7) {
        shifter.setPin(LEDSEQ[(0)], 0);
      }

      if ((step_counter == sequence_length_buffer - 1) && (sequence_length_buffer > 8)) {
        shifter.setPin(LEDSEQ[(0)], 0);
      }
    }

    if (seq_direction == 2) {
      if (step_time_flag) {
        shifter.setPin(LEDSEQ[step_counter], step_state[step_counter]);
        shifter.setPin(LEDSEQ[previous_step_counter], 0);
      }
    }

    //LED management for seq_on/off
    shifter.setPin(21, seq_on);

    //LED management for MIDI CLOCK
    //
    if (PBSTATUS[6]) {
      shifter.setPin(22, !midi_clock);
    }

    //    if ((!seq_on) && (midi_clock)) {
    //      shifter.setPin(22, 1);
    //    }

    if ((!seq_on)) {
      shifter.setPin(22, midi_clock);
    }

    //LED management for page number
    if (seq_page == 0) {
      shifter.setPin(17, 0);
      if (blink_sequencer > 150) {
        shifter.setPin(16, blink1);
        blink_sequencer = 0;
        blink1 = !blink1;
      }
    }

    else {
      shifter.setPin(16, 0);
      if (blink_sequencer > 150) {
        shifter.setPin(17, blink2);
        blink_sequencer = 0;
        blink2 = !blink2;
      }
    }

    //LED manangement for shift control
    switch (shift) {

      case 4:
        shifter.setPin(26, 1);
        shifter.setPin(27, 0);
        shifter.setPin(28, 0);
        break;

      case 5:
        shifter.setPin(26, 0);
        shifter.setPin(27, 1);
        shifter.setPin(28, 0);

        break;

      case 6:
        shifter.setPin(26, 0);
        shifter.setPin(27, 0);
        shifter.setPin(28, 1);
        break;
    }

    //LED manangement for shift control
    switch (resolution) {

      case 12:
        shifter.setPin(18, 1);
        shifter.setPin(19, 0);
        shifter.setPin(20, 0);
        break;

      case 24:
        shifter.setPin(18, 0);
        shifter.setPin(19, 1);
        shifter.setPin(20, 0);

        break;

      case 60:
        shifter.setPin(18, 0);
        shifter.setPin(19, 0);
        shifter.setPin(20, 1);
        break;
    }

    switch (seq_direction) {

      case 1:
        shifter.setPin(23, 1);
        shifter.setPin(24, 0);
        shifter.setPin(25, 0);
        break;

      case 2:
        shifter.setPin(23, 0);
        shifter.setPin(24, 1);
        shifter.setPin(25, 0);

        break;

      case 3:
        shifter.setPin(23, 0);
        shifter.setPin(24, 0);
        shifter.setPin(25, 1);
        break;
    }

  }

  shifter.write();
}

