void Sequencer() {

  if (SEQ_IN) {
    for (int i = 0; i < 29; i++) {
      shifter.setPin(LEDPINS[i], 0);
    }
  }

  //recalculate the clock value according to the
  float manual_clock = (60 / tempo_buffer) * (1000000) * (4 / clock_divider_buffer);

  //if clock is on manual!
  if (!midi_clock) {

    if (step_timer > manual_clock) {
      step_time();
      step_timer = 0;
    }
  }

  //  if clock is on midi clock
  if (midi_clock) {
    if (midi_clock_flag) {
      step_time();
      midi_clock_flag = 0;
    }
  }

  if (SEQ_MODE) {

    // takes the analog input of the interface 16 first faders
    for (int i = 0; i < sequence_length_buffer; i++) {
      Analog_resoluted[i] = map(Analog[i], 0, 1020, 0, resolution);

      if ((Analog_resoluted[i] > Previous_Analog_resoluted[i]) || (Analog_resoluted[i] < Previous_Analog_resoluted[i])) {
        seq_notes_buffer[i] = Analog_resoluted[i] ;
      }

      if (SEQ_IN) {
        seq_notes_buffer[i] = seq_notes[i];
      }

      Previous_Analog_resoluted[i] = Analog_resoluted[i];
    }

    // Read the ARP tempo fader and store mapped into tempo
    tempo = map(Analog[21], 0, 1020, 0, 240);
    if (SEQ_IN) {
      old_tempo = tempo;
    }

    if (tempo != old_tempo) {
      tempo_buffer = tempo;
    }

    old_tempo = tempo;

    // Read the DCO fader and store sequence length
    sequence_length = map(Analog[19], 0, 1020, 0, 16);
    if (SEQ_IN) {
      old_sequence_length = sequence_length;
    }

    if (sequence_length != old_sequence_length) {
      sequence_length_buffer = sequence_length;
      for (int i = 0; i < 29; i++) {
        shifter.setPin(LEDPINS[i], 0);
      }
      shifter.write();

      old_sequence_length = sequence_length;
    }

    // Read the ARP tempo fader and store mapped into tempo
    if (Analog[18] > 0) {
      clock_divider = 2; //lowest position fader 1/2
    }
    if (Analog[18] > 205) {
      clock_divider = 4; //1/4
    }
    if (Analog[18] > 410) { //1/8
      clock_divider = 8;
    }
    if (Analog[18] > 615) { //1/16
      clock_divider = 16;
    }
    if (Analog[18] > 820) { //1/32
      clock_divider = 32;
    }

    if (SEQ_IN) {
      old_clock_divider = clock_divider;
    }

    if ((clock_divider > old_clock_divider) || (clock_divider < old_clock_divider)) {
      new_divider = 1;

      if (!midi_clock) {
        clock_divider_buffer = clock_divider;
      }
    }
    old_clock_divider = clock_divider;

    SEQ_IN = 0;

    // toggles step_stages
    for (int i = 0; i < 8; i++) {
      if (PBSTATUS[step_index[i]]) {
        step_state[i + seq_page * 8] = !step_state[i + seq_page * 8] ;
      }
    }

    // toggles between page 0 and 1
    if (PBSTATUS[3]) { //Go to page 0 (chorus I)
      seq_page = 0;
      for (int i = 0; i < 8; i++) {
        shifter.setPin(LEDSEQ[i], 0);
      }
    }

    if (PBSTATUS[4]) { //Go to page 1 (chorus II)
      seq_page = 1;
      for (int i = 0; i < 8; i++) {
        shifter.setPin(LEDSEQ[i], 0);
      }
    }

    //Toggles seq on and off
    if (PBSTATUS[5]) {
      seq_on = !seq_on;
      if (!seq_on) { //when sequencer is turnoff, send midi off for all notes and turn off all leds
        for (int i = 0; i < 127; i++) {
          usbMIDI.sendNoteOff(i, 127, 1);
        }

        for (int i = 0; i < 8; i++) {
          shifter.setPin(LEDSEQ[i], 0);

        }
        step_counter = 0;
      }
    }

    //Toggles midi clock on and off
    if (PBSTATUS[6]) {
      midi_clock = !midi_clock;
      for (int i = 0; i < 127; i++) {
        usbMIDI.sendNoteOff(i, 127, 1);
      }
    }

    //Toggles different shift values
    if (PBSTATUS[14]) {
      for (int i = 0; i < 127; i++) {
        usbMIDI.sendNoteOff(i, 127, 1);
      }
      switch (shift) {
        case 4:
          shift = 5;
          break;

        case 5:
          shift = 6;
          break;

        case 6:
          shift = 4;
          break;
      }
    }

    //Toggles different resolution values
    if (PBSTATUS[13]) {
      for (int i = 0; i < 127; i++) {
        usbMIDI.sendNoteOff(i, 127, 1);
      }
      switch (seq_direction) {
        case 1:
          seq_direction = 2;
          step_counter = byte(random(sequence_length - 1));
          break;

        case 2:
          seq_direction = 3;
          seq_direction_ratio = -1;
          break;

        case 3:
          seq_direction = 1;
          seq_direction_ratio = 1;
          break;
      }
    }

    if (seq_direction == 2) {
    }

    if (PBSTATUS[12]) {
      for (int i = 0; i < 127; i++) {
        usbMIDI.sendNoteOff(i, 127, 1);

      }
      switch (resolution) {
        case 12:
          resolution = 24;
          break;

        case 24:
          resolution = 60;
          break;

        case 60:
          resolution = 12;
          break;
      }
    }

  }


}

